// CodeGear C++Builder
// Copyright (c) 1995, 2010 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'IWTMSAuthBase.pas' rev: 22.00

#ifndef IwtmsauthbaseHPP
#define IwtmsauthbaseHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <WinInet.hpp>	// Pascal unit
#include <DBXJSON.hpp>	// Pascal unit
#include <HTTPApp.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <IWApplication.hpp>	// Pascal unit
#include <IdGlobal.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Iwtmsauthbase
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TIWResult { resNone, resOK, resFailed };
#pragma option pop

class DELPHICLASS TAuthClient;
class DELPHICLASS TAuthClients;
class DELPHICLASS TTIWCustomCloudClient;
class PASCALIMPLEMENTATION TAuthClient : public Classes::TCollectionItem
{
	typedef Classes::TCollectionItem inherited;
	
private:
	TAuthClients* FOwner;
	System::UnicodeString FName;
	int FTag;
	System::UnicodeString FID;
	TTIWCustomCloudClient* FClient;
	void __fastcall SetClient(const TTIWCustomCloudClient* Value);
	void __fastcall SetID(const System::UnicodeString Value);
	
public:
	__fastcall virtual TAuthClient(Classes::TCollection* Collection);
	__fastcall virtual ~TAuthClient(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	
protected:
	virtual System::UnicodeString __fastcall GetDisplayName(void);
	
__published:
	__property TTIWCustomCloudClient* Client = {read=FClient, write=SetClient};
	__property System::UnicodeString ID = {read=FID, write=SetID};
	__property System::UnicodeString Name = {read=FName, write=FName};
	__property int Tag = {read=FTag, write=FTag, default=0};
};


class DELPHICLASS TTIWAuthServerController;
class PASCALIMPLEMENTATION TAuthClients : public Classes::TCollection
{
	typedef Classes::TCollection inherited;
	
public:
	TAuthClient* operator[](int Index) { return Items[Index]; }
	
private:
	TTIWAuthServerController* FOwner;
	TAuthClient* __fastcall GetItems(int Index);
	void __fastcall SetItems(int Index, const TAuthClient* Value);
	
protected:
	virtual void __fastcall Update(Classes::TCollectionItem* Item);
	
public:
	__fastcall TAuthClients(TTIWAuthServerController* AOwner);
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	HIDESBASE TAuthClient* __fastcall Add(void);
	HIDESBASE TAuthClient* __fastcall Insert(int Index);
	__property TAuthClient* Items[int Index] = {read=GetItems, write=SetItems/*, default*/};
public:
	/* TCollection.Destroy */ inline __fastcall virtual ~TAuthClients(void) { }
	
};


class DELPHICLASS TIWApp;
class PASCALIMPLEMENTATION TIWApp : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	System::UnicodeString FID;
	System::UnicodeString FSecret;
	void __fastcall SetID(const System::UnicodeString Value);
	void __fastcall SetSecret(const System::UnicodeString Value);
	
public:
	__fastcall TIWApp(void);
	
__published:
	__property System::UnicodeString ID = {read=FID, write=SetID};
	__property System::UnicodeString Secret = {read=FSecret, write=SetSecret};
public:
	/* TPersistent.Destroy */ inline __fastcall virtual ~TIWApp(void) { }
	
};


class PASCALIMPLEMENTATION TTIWCustomCloudClient : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	bool FDesignTime;
	TIWApp* FApp;
	System::UnicodeString FLoginUsername;
	System::UnicodeString FLoginID;
	TTIWAuthServerController* FServerController;
	TIWResult FLoginResult;
	System::UnicodeString FLoginError;
	Classes::TNotifyEvent FOnLoginOK;
	Classes::TNotifyEvent FOnLoginFailed;
	Classes::TStringList* FScope;
	void __fastcall SetServerController(const TTIWAuthServerController* Value);
	
protected:
	__property TIWApp* App = {read=FApp, write=FApp};
	__property System::UnicodeString LoginUsername = {read=FLoginUsername, write=FLoginUsername};
	__property System::UnicodeString LoginID = {read=FLoginID, write=FLoginID};
	__property Classes::TStringList* Scope = {read=FScope, write=FScope};
	__property Classes::TNotifyEvent OnLoginOK = {read=FOnLoginOK, write=FOnLoginOK};
	__property Classes::TNotifyEvent OnLoginFailed = {read=FOnLoginFailed, write=FOnLoginFailed};
	virtual void __fastcall Login(const Iwapplication::TIWApplication* WebApplication);
	virtual void __fastcall LoginResponse(const Httpapp::TWebRequest* Request);
	
public:
	__fastcall virtual TTIWCustomCloudClient(Classes::TComponent* AOwner);
	__fastcall virtual ~TTIWCustomCloudClient(void);
	__property TIWResult LoginResult = {read=FLoginResult, write=FLoginResult, nodefault};
	__property System::UnicodeString LoginError = {read=FLoginError, write=FLoginError};
	
__published:
	__property TTIWAuthServerController* ServerController = {read=FServerController, write=SetServerController};
};


class PASCALIMPLEMENTATION TTIWAuthServerController : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	bool FDesignTime;
	TAuthClients* FClients;
	
public:
	__property TAuthClients* Clients = {read=FClients, write=FClients};
	__fastcall virtual TTIWAuthServerController(Classes::TComponent* AOwner);
	__fastcall virtual ~TTIWAuthServerController(void);
	void __fastcall ProcessRequest(const Httpapp::TWebRequest* Request);
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall ParseJSON(System::UnicodeString Data, Dbxjson::TJSONObject* &JSONObject);
extern PACKAGE void __fastcall Split(const System::WideChar Delimiter, System::UnicodeString Input, const Classes::TStrings* Strings);
extern PACKAGE System::UnicodeString __fastcall GenerateNonce(void);
extern PACKAGE System::UnicodeString __fastcall GenerateTimeStamp(void);
extern PACKAGE System::UnicodeString __fastcall Base64Encode(const System::DynamicArray<System::Byte> Input);
extern PACKAGE System::DynamicArray<System::Byte> __fastcall EncryptHMACSha1(System::UnicodeString Input, System::UnicodeString AKey);
extern PACKAGE System::UnicodeString __fastcall Https_Get(const System::UnicodeString ServerName, const System::UnicodeString Resource, System::AnsiString &Response);
extern PACKAGE int __fastcall Https_Post(const System::UnicodeString ServerName, const System::UnicodeString Resource, const System::UnicodeString Header, const System::AnsiString PostData, System::AnsiString &Response);
extern PACKAGE System::UnicodeString __fastcall URLEncode(const System::UnicodeString S);
extern PACKAGE System::UnicodeString __fastcall EncodeParams(Classes::TStringList* Params, System::UnicodeString splitter, bool quot, bool encodeHttp = false);
extern PACKAGE System::UnicodeString __fastcall CreateGuid(void);

}	/* namespace Iwtmsauthbase */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE)
using namespace Iwtmsauthbase;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// IwtmsauthbaseHPP
